<template>
  <div
    :id="id"
    class="modal fade"
    tabindex="-1"
    role="dialog"
    aria-labelledby="myModalLabel"
  >
    <div
      class="modal-dialog"
      role="document"
    >
      <div class="modal-content">
        <div class="modal-header">
          <button
            v-if="cannotClose==='false'"
            type="button"
            class="close"
            data-dismiss="modal"
            aria-label="Close"
          >
            <span aria-hidden="true">&times;</span>
          </button>
          <h4
            id="myModalLabel"
            class="modal-title"
          >
            {{ title }}
          </h4>
        </div>
        <div class="modal-body">
          <slot name="content" />
          <label for="check">{{ checkLabel }}&nbsp;:</label>
          <input
            id="check"
            v-model="text"
            name="check"
            type="text"
            class="form-control"
            required="required"
          >
        </div>
        <div class="modal-footer">
          <click-button
            v-if="cancelLabel"
            data-dismiss="modal"
          >
            <template #content>
              {{ cancelLabel }}
            </template>
          </click-button>
          <click-button
            v-if="okLabel"
            :disabled="disableOkButton"
            @click="next"
          >
            <template #content>
              {{ okLabel }}
            </template>
          </click-button>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import ClickButton from "../Button/ClickButton";
export default {
  name: "InputProtectedModal",
  components: {ClickButton},
  props: {
    id: {
      type: String,
      default: ''
    },
    show: {
      type: String,
      default: ''
    },
    title: {
      type: String,
      default: ''
    },
    cancelLabel: {
      type: String,
      default: ''
    },
    okLabel: {
      type: String,
      default: ''
    },
    cannotClose: {
      type: String,
      default: "false"
    },
    textToCheck: {
      type: String,
      default: ''
    },
    checkLabel: {
      type: String,
      default: ''
    }
  },
  data() {
    return {
      text: ''
    }
  },
  computed: {
    disableOkButton() {
      return this.text !== this.textToCheck
    }
  },
  mounted() {
    if(this.show==="true") {
      $('#'+this.id).modal({keyboard:false,backdrop:'static'})
    }
    $('#'+this.id).on('hidden.bs.modal', function () {
      $('.modal-backdrop').remove()
    })
  },
  methods: {
    next() {
      $('#'+this.id).modal('hide')
      this.$emit('okClicked')
    }
  }
}
</script>

<style scoped>

</style>